if not TidyPlatesThemeList then TidyPlatesThemeList = {} end

-------------------------------------------------------------------------------------
-- Template
-------------------------------------------------------------------------------------

local theme = {}
local defaultArtPath = "Interface\\Addons\\TidyPlates\\Media"
local font =					"FONTS\\arialn.ttf"

theme.hitbox = {
	width = 149,
	height = 37,
}

theme.healthborder = {
	texture		 =				defaultArtPath.."\\Empty",
	glowtexture =					defaultArtPath.."\\Empty",
	elitetexture =					defaultArtPath.."\\Empty",
	width = 128,
	height = 64,
	x = 0,
	y = -5,
	anchor = "CENTER",
}


theme.threatborder = {
	texture =			defaultArtPath.."\\Empty",
	elitetexture =			defaultArtPath.."\\Empty",
	width = 128,
	height = 64,
	x = 0,
	y = -5,
	anchor = "CENTER",
}

theme.castborder = {
	texture =					defaultArtPath.."\\Empty",
	width = 128,
	height = 64,
	x = 0,
	y = -11,
	anchor = "CENTER",
}

theme.castnostop = {
	texture = 				defaultArtPath.."\\Empty",
	width = 128,
	height = 64,
	x = 0,
	y = -11,
	anchor = "CENTER",
}

theme.name = {
	typeface =					font,
	size = 9,
	width = 88,
	height = 10,
	x = 0,
	y = 1,
	align = "LEFT",
	anchor = "LEFT",
	vertical = "BOTTOM",
	shadow = true,
	flags = "NONE",
}

theme.level = {
	typeface =					font,
	size = 9,
	width = 25,
	height = 10,
	x = 36,
	y = 1,
	align = "RIGHT",
	anchor = "CENTER",
	vertical = "BOTTOM",
	shadow = true,
	flags = "NONE",
}

theme.healthbar = {
	texture =					 defaultArtPath.."\\Empty",
	backdrop = 				defaultArtPath.."\\Empty",
	height = 12,
	width = 101,
	x = 0,
	y = 10,
	anchor = "CENTER",
	orientation = "HORIZONTAL",
	texcoord = {left = 0,right = 1,top = 0,bottom = 1}, 
}

theme.castbar = {
	texture =					defaultArtPath.."\\Empty",
	backdrop = 				defaultArtPath.."\\Empty",
	height = 12,
	width = 99,
	x = 0,
	y = -19,
	anchor = "CENTER",
	orientation = "HORIZONTAL",
	texcoord = {left = 0,right = 1,top = 0,bottom = 1}, 
}

--[[
	
	Texture Coordinate Explanation
	coords.left, coords.right, coords.top, coords.bottom
	
	+----- 0 -----+
	|             |
	|             |
	0      | ---> 1
	|      |      |
	|      V      |
	+----- 1 -----+
	
	+----- 0 -----+
	|             |
	|      |      |
	0      V      1
	| ... 0.75 .. |
	|             |
	+----- 1 -----+
	
--]]

theme.specialText = {
	typeface =					font,
	size = 9,
	width = 93,
	height = 10,
	x = 0,
	y = 11,
	align = "RIGHT",
	anchor = "CENTER",
	vertical = "BOTTOM",
	shadow = true,
	flags = "NONE",
}

theme.specialText2 = {
	typeface =					font,
	size = 8,
	width = 100,
	height = 10,
	x = 1,
	y = -19,
	align = "LEFT",
	anchor = "CENTER",
	vertical = "BOTTOM",
	shadow = true,
	flags = "NONE",
}

theme.specialArt = {
	width = 24,
	height = 24,
	x = -5,
	y = 10,
	anchor = "TOP",
}

theme.spellicon = {
	width = 18,
	height = 18,
	x = 62,
	y = -19,
	anchor = "CENTER",
}

theme.raidicon = {
	width = 20,
	height = 20,
	x = -35,
	y = 7,
	anchor = "TOP",
}

theme.dangerskull = {
	width = 14,
	height = 14,
	x = 44,
	y = 3,
	anchor = "CENTER",
}

theme.frame = {
	width = 101,
	height = 45,
	x = 0,
	y = -5,
	anchor = "CENTER",
}

theme.threatcolor = {
	LOW = { r = .75, g = 1, b = 0, a= 1, },
	MEDIUM = { r = 1, g = 1, b = 0, a = 1, },
	HIGH = { r = 1, g = 0, b = 0, a = 1, },
}

theme.options = {
	showLevel = true,
	showName = true,
	showSpecialText = false,
	showSpecialText2 = false,
	showSpecialArt = false,
	showDangerSkull = true,
	showSpellIcon = true,
	showNostopSpell = true,
	showAggroGlow = true, 
}

--[[  Delegate Functions

-- Appearance and Indicators
theme.SetSpecialText = function(unit) return "Text to Display" end
theme.SetSpecialText2 = function(unit) return "Text to Display" end
theme.SetScale = function(unit) local scale = 1; return scale end
theme.SetAlpha = function(unit) local alpha = 1; return alpha end
theme.SetHealthbarColor = function(unit) local r, g, b = 1, 1, 1; return r, g, b end
theme.SetThreatColor = function(unit) local r, g, b = 1, 1, 1, a; return r, g, b, a end

-- Advanced Behaviors & Widgets
theme.OnInitialize = function(frame) end
theme.OnUpdate = function(frame, unit) end
theme.OnContextUpdate = function(frame, unit) end	

--]]

--[[

-- Unit Information Table 
unit.threatSituation				"LOW", "MEDIUM", "HIGH"	
unit.reaction						"FRIENDLY", "NEUTRAL", "HOSTILE"
unit.type							"NPC", "PLAYER"
unit.isBoss							true, if the skull icon is active (the creature is a boss/level ??)
unit.isDangerous					Same as isBoss
unit.isElite						true, if unit is elite (ie. elite symbol is shown)
unit.isMarked						true, if the unit is marked with a raid icon
unit.name							the unit's name
unit.alpha							float, the alpha of the nameplate (ie. 1 = target, Less than 1 = non-target)
unit.level							integer, the unit's level
unit.health							integer, the unit's health
unit.isMouseover					true, if the highlight region is showing (ie. mouse is over the frame)
unit.red, unit.green, unit.blue 	0.0-1 Values, the raw color of the health bar
unit.isCasting						true, if cast bar is being shown
_, unit.healthmax 					integer, the maximum health of the unit
unit.class 							"DEATHKNIGHT", "DRUID","HUNTER", etc.. Only for PvP Enemies
unit.isInCombat	- DEPRECIATED 		true, if name text is red (ie. unit is in combat with you)
--]]
TidyPlates.Template = theme
TidyPlates:ActivateTheme(theme)		-- Activates the template as a holder theme, until the user preference is loaded

------------
-- "Name Only" Theme
------------
TidyPlatesThemeList["None"] = {}
local NameOnlyTheme = TidyPlatesThemeList["None"]
NameOnlyTheme.name = {
	size = 13,
	width = 200,
	height = 16,
	x = 0,
	y = 12,
	align = "CENTER",
	anchor = "CENTER",
	shadow = true,
	--flags = "OUTLINE",
}

NameOnlyTheme.options = {
	showLevel = false,
	showName = true,
	showSpecialText = false,
	showSpecialText2 = false,
	showSpecialArt = false,
	showDangerSkull = false,
	showSpellIcon = false,
	showNostopSpell = false,
	showAggroGlow = false, 
}


